===============================================================================
Version 3.2
===============================================================================

Patchlevel 1  (July 1, 1998)

NEW FEATURES
	o New driver for tk (tcl/tk) - Generates canvas objects and canvas.
	  from Mike Markowski (mm@udel.edu)
	o -h option to print all options for all output languages
	o Japanese text support for LaTeX output
	  from T. Sato (VEF00200@niftyserve.or.jp)

BUGS FIXED
	o XPMLIB renamed to XPMLIBS in Imakefile because of conflict with
	  XFree86 variable name in xmkmf config files
	o Fixed bug in JPEGINCDIR path when relative path is used (when
	  USEINSTALLEDJPEG is *not* used) - the dev directory is one level
	  deeper so "../" is prepended for that case
	o The rest of the scaling problems for latex fixed :-)
	  from Hans Werner Strube (strube@physik3.gwdg.de)
	o fig2dev can now be used in a pipe (e.g. cat x.fig | fig2dev -L ps ...)
	  was attempting to rewind file before
	o Two bugs fixed in eepic driver
		1) -l option didn't work because DPI was 0 when line width was
		   defined
		2) -W option produced 0 line widths because of a bad fprintf
	o Dash length incorrect by factor of 80 for LaTeX output
	o I18N support added for LaTeX output
	o Incorrect amount of memory allocated for reading eps pictures
	o Bug in provided strstr() (only used if you've uncommented
	  #define NOSTRSTR in the Imakefile)
	o Fixed M_PI incompatibility with RedHat 5.0
	o moved convert_names procedure from readxpm.c into genps.c since only
	  genps.c needs it.  Removed readxpm.c as a result.
	o added missing PCX import driver
	o metric scaling for latex part fixed
	  From Martin Pahl <pahl@tnt.uni-hannover.de>
	o Some Linuxes need -lgdbm instead of -ldbm (fig2dev/Imakefile)
	o transparent color for GIF was not passed (new option -t)
	o multiple co-incident points in splines caused problems on some
	  machines (this patch was in the old spline model but failed to make
	  it to the X-Spline model)
	o endpoints of splines were missing sometimes
	o new #ifdef for glibc which already has sys_errlist defined
	o conflict with definition M_PI (3.14159....) on RedHat systems fixed
	o "Ledger" paper size removed from list of paper sizes.  It is really
	  "Tabloid" size in landscape mode.
	o arrowheads were too far back from end of line
	o dash length for lines were too large in LaTeX output
	o fig2dev can now be used in a pipe (e.g. cat x.fig | fig2dev -L ps ...)
	  was attempting to rewind file before
	o error in I18N defines in fig2dev/Imakefile
	o buggy strstr() proc in fig2dev source replaced by xfig's version
	  (only used for systems that don't have their own strstr() )
	o bug fixes and modernization of Metafont driver by Mats Bengtsson
	  <mats.bengtsson@s3.kth.se>
	o removed stricmp() function in dev/genepic.c because strcasecmp() is
	  equivalent

===============================================================================
Version 3.2 (first release Aug 22, 1997)
===============================================================================

NEW FEATURES
	o flag in transfig/Imakefile to use "\usepackage" for LaTeX2e instead of
	  "\documentstyle" for LaTeX209.  See README file.
	o fig2dev now handles the bitmap formats (GIF, JPEG etc) instead of xfig,
	  so there is more consistent output. Requires the (free) netpbm package.
	  See the README file.
	o tiff (no compression) and AutoCad (acad) output languages added
	o image quality (0-100) is selectable for JPEG export (-q option)

BUGS FIXED
	o changed XPM variables to default X include/library in fig2dev/Imakefile
	o remove PageSize comment if EPS (no showpage)
	o bug in colormap for imported grayscale JPEG files
	o "rs gr" sequence after imported eps file changed to "restore grestore"
	  in case imported eps file had defined either "rs" or "gr"
	o There was a bug in the EPIC driver when drawing backward arrows - in
	  several places in genepic.c draw_arrow_head is called with unconverted
	  coordinates, which leads to totally displaced arrows.
	  from Heiko Schroeder (heiko@linux.local.de)
	o cleanup of dictionary wrapped around imported EPS files 
	  from Franz Koch (franz.koch@zdv.uni-tuebingen.de)
	o pic output didn't produce dashed or dotted arc
	o metric flag incorrectly parsed
	o strcasecmp and strncasecmp bugs (s2 != '\0' and s2 == '\0' should
	  be *s2 ...)
	o error in JPEGINCDIR in fig2dev/Imakefile
	o rec_array wasn't being freed in gendev_objects (fig2dev.c)
	o thicklines not being set properly for LaTeX output
	o two-point splines looped infinitely on some machines
	  fixed by Jeff Dairiki <dairiki@kalman.apl.washington.edu>
	o arrowheads weren't correct on tight arcs in eepic output
	  fixed by Wolfgang Reissenberger <reissenb@veilchen.informatik.uni-stuttgart.de>
	o TransFig now uses \usepackage instead of \documentstyle, which is old
	  From Klaus Georg Barthelmann (barthel@Informatik.Uni-Mainz.DE)
	o fill pattern of rotated ellipses was rotated itself
	o Ledger/Tabloid sizes reversed (Tabloid is 11x17", Ledger is 17x11")
	o bounding box of text more accurate for text with/without descenders
	o added USEINLINE variable in Imakefile to use compiler inline functions
	o removed ANSI prototypes from spline routines in trans_spline.c

------------------------------
Version 3.2 Beta (Jan 9, 1997)
------------------------------

NEW FEATURES

o multi-page, paper size, magnification and transparent color stored in Fig
	file now.  (transparent color is only used by xfig when exporting 
	to GIF format)
o comment that Redhat Linux users may have to change DBMLIB to -ldb in
	fig2dev/Imakefile
o figures in landscape are only rotated when showpage command is NOT used 
	(-P).  This is because it doesn't need to be rotated for EPS,
o previous spline models (interpolated splines and approximated splines) are
  replaced by one single model (x-splines) which allows the user to mix
  interpolated and approximated control points (see the "FORMAT3.2" file
  from the "xfig" package for details).

BUGS FIXED

o added second % to %%BeginDocument and %%EndDocument
o garbage values for arrowhead produced when last two points in line were at
	same coordinate
o bug in reading multi-line text object
o showpage now follows restore as per standard
	from Christopher R. Wren (chris@wren.cambridge.ma.us)

===============================================================================
Version 3.1
===============================================================================
Patchlevel 2a (Jun 4, 1996)

NEW FEATURES

o only need to change XPM defines in fig2dev/Imakefile
o if your system has the strerror() function (doesn't have sys_errlist) then
	comment out NEED_STRERROR with an XCOMM comment.
o new option for PostScript output, "-e" to force figure to edge (flush-left).
	Useful when the figure was saved with Centering on.
o point objects (POLYLINE with only one point) have thickness now and will be
	filled circles if cap style is rounded.  PostScript output only.
o -A option to scale arrowhead sizes for epic driver
o can rotate all text (not just left justified) in LaTeX now using \rotatebox.
	The old restriction is not needed because the epsfig package is
	required to include ps_tex_t files anyway.
o new line types - Dash-dot (_.) Dash-dot-dot (_..) and Dash-dot-dot-dot (_...)
o new paper sizes: "Tabloid", "Ledger", "B", "C", "D", "E", "A0", "A1", "A2", 
	"A3", "A4" and "B5".  See man fig2dev (-z option) for sizes in
	inches and cm

BUGS FIXED

o double colon (::) needed for .man installation in Imakefiles
o linewidth wasn't working correctly in epic/eepic driver
	from Andre Eickler (eickler@db.fmi.uni-passau.de)
o some versions of imake don't like null parameters in SpecialObjectRule in
	Imakefile - changed to "NullParameter"
o the text alignment problem in LaTeX output has been fixed (genlatex.c)
	From Francky Leyn (Francky.Leyn@esat.kuleuven.ac.be)
o if the endpoints of a POLYLINE are coincident, the line join parameter will
	be used to join them (xfig already showed this behavior)
o redefined $(XPMINCDIR) to $(XPMINC) because some compilers have trouble with
	header search path with empty "-I"
o incorrect directory specified for xpm.h in fig2dev/dev/genps.c and readxpm.c
o changed "ln -s" commands in Imakefiles to "-ln -s" so make will continue if
	symlinks are already in place
o back arrows incorrect for splines and lines in epic driver
o figure was clipped to pagesize even in EPS mode
o if paper size specified as "Ledger" in landscape mode fig2dev switches to
	"Tabloid" paper size and vice versa (Tabloid in portrait mode switches
	to Ledger)
o segfault when importing jpeg picture with grayscale colormap fixed
o colormap must be saved before jpeg_finish_decompress or
	jpeg_destroy_decompress are called in read_JPEG_file()
o #include <jpeglib.h> changed to #include "jpeglib.h" to ensure corrrect path
	used to find header file
o moved %Magnification information in PostScript output after %%BoundingBox
	(caused problems for some programs interpreting DSC PostScript)
o incorrect spline line thickness when multiple splines are used
o arrowheads caused DOMAIN error for asin on very small arcs
o include ctype.h in fig2dev.h for isascii() and isxdigit() macros
o removed redundant #ifdef NOSTRSTR from strstr.c because that file is only
	compiled if system has no strstr()
o error when using first user-defined color (color 32)
o fabs(), sin(), cos(), atan() and acos() redefined in genlatex.c, genpictex.c,
	genpstex.c and gentextyl.c
o error message about being unable to open eps file was mis-formatted
o multiple whitespace following "(atend)" in EPS file parsed correctly now
	from T. Sato (VEF00200@niftyserve.or.jp)
o extraneous variable in fprintf in genps.c
	from T. Sato
o extraneous % in fprintf in genepic.c (set_pattern)
o multi-page option shifted all pages incorrectly
o error in scanf format string for reading text from old (Fig 1.3) files
	from T. Sato
o error in fprintf format string for virtual font in gentpic driver
	from T. Sato
o erroneous "extern" declarations for cur_capstyle and cur_joinstyle in two
	dev/genps.c functions
o bug in skip_comment() which prevented some machines from seeing the end of
	file, giving erroneous "Incorrect format" error

---------------------------------------------------------------------------
Patchlevel 2 (Aug 16, 1995)

New Features:

o JPEG (JFIF) pictures objects supported for PostScript output
o %Magnification: comment added to PostScript output showing magnification
o the points of arrow heads don't protrude past the endpoints of the object

Bugs Fixed:

o the radius of arc-box corners is limited to the half of the smaller of the
	two sides of the box to avoid PostScript errors
o pstex driver incorrectly omitted postscript text in pstex output
o set_linewidth was passed double instead of int from fdraw_arrow_head
	in genepic.c
o length of dotted line dots too small for high resolution printers
o recursion bug fixed where run-time would increase exponentially with nesting
	of compound objects
o %%BeginDocument:/EndDocument now surrounds imported EPS files
o open arrowheads on arcs were overwritten by arc lines 
o bug in pattern fill code which made patterns appear solid black when
	using dvips
	Thanks to Tomas Rokicki (rokicki@CS.Stanford.EDU) for finding the fix
o line thickness wasn't adjusted for new resolution in epic, eepic, pic, tpic
	and pictex drivers
o dash length incorrect for Fig 3.x files in pic and pictex drivers
o -s option to fix text pointsize wasn't being honored
o documentation typo with regard to rigid text.  Rigid text means that the font
	size doesn't change when text is inside a compound object and that
	object is scaled in xfig.  Not used for fig2dev.
o certain machines don't handle atan2(y,0.0) so arcs with endpoints having the
	same x value were incorrectly calculated
o some machines don't calculate hypot(x,y) correctly so changed to sqrt(x*x+y*y)
	in arc_bound()
o bug in calculating BoundingBox for PostScript in compound objects
o cleared up confusion about -DNFSS and -DEPSF.  Here is the final word:

  Add -DNFSS to DEFINES list to use NFSS2 font selection for LaTeX texts
  Add -DEPSF to DEFINES list to use epsfig macros as distributed w/ LaTeX2e
 
 	Hint: Users of LaTeX2e will probably want to include both of these
 	options; users of LaTeX 2.09 will probably want to include neither.

o new tints added (fill values 21-40) and arrowhead types for epic driver
     from Andre Eickler (eickler@db.fmi.uni-passau.de)
o pattern fill seg faulted for epic/eepic output (only PostScript has patterns)
o sanity check for font number
o font name "Modern" changed to more correct "Sans Serif" in documentation
o MetaFont driver only sent output to stdout
o version information (fig2dev -V) said "TransFig" instead of "fig2dev"
o getopt.c not needed for Solaris - #if (defined(...)) added in Imakefile
	for this
o removed duplicate #define of FALSE, TRUE and DEFAULT_FONT_SIZE in various
	drivers

---------------------------------------------------------------------------
Patchlevel 1 (Jan 24, 1995)

Bugs Fixed:

o eps files with binary data (!) now handled correctly
o -f option to PostScript driver with unknown PostScript font name caused
	seg fault
o increased resolution of unitlength specifier in latex/epic drivers - was
	rounding 0.00083333 to 0.0008.
o dash length not set correctly for epic driver
o area fill values incorrectly interpreted for some drivers other than
	PostScript - this also made fig2dev outpus spurious %s%s(%d%d)}
	for epic/eepic
o linejoin set instead of linecap in postscript output
o sets linecap to ROUND for ellipses and closed splines with dotted lines
o defines showpage as null for included EPS files instead of removing the
	word "showpage" from them
o definition for XCOMM in Imakefiles for those running R4
o bug in freeing xpm image structure incompatible pointer type
o bug in fig2dev/Imakefile variable for including -ldbm explicitly
o removed -lnsl option from fig2dev/dev/Imakefile - imake files should
	automatically add this to the Makefile for Solaris (SVR4) systems
o note added to README that you must do "make" before "make install"
o bug in reading text for linux os - text size was set to 0
o bcopy changed to memcpy call in dev/readpics.c
o SVR4 condition added to transfig/transfig.h for including string.h
o variable in fig2dev/Imakefile and fig2dev/dev/Imakefile for include
	directory for xpm files if your xpm headers are not in the default X11
	include directory

---------------------------------------------------------------------------
Patchlevel 0 (Jan 9, 1995)

o NOTE:	An error in xfig version 3.0.0 incorrectly positioned objects on the
	canvas when reading older fig files.  New objects entered with 3.0 are
	correctly positioned.  
	I apologize for the inconvenience.
*****	This is the only reason why the file protocol number has changed.

Bugs Fixed:

o error when figure was larger or partially off the page and user did not
	select multipage option (-M)
o newline() declared twice (inconsistently) in dev/gentpic.c
o errors in read.c for linux machines - caused font size 0
o Linux machines need LOCAL_LDFLAGS = -ldbm in fig2dev/Imakefile
o sys/types.h needed in dev/readpics.c for BSD machines

===============================================================================
Version 3.0
===============================================================================
Transfig version 3.0.0 (Dec 22, 1994)

New Features:

o MetaFont driver added (from fig2mf)
	from Anthony Starks (ajs@merck.com)
o "-n name" option to specify filename for PostScript Title (e.g. when using
	stdin)
o -x <offset> and -y <offset> options for PostScript output to shift figure on
	page.
o fig2dev/dev/Imakefile settings to:
     1. Use LaTeX2e commands for setting fonts. As LaTeX2e will become the
	official release by spring this year (we redefined the start of
	spring to be the date the LaTeX is released). This is a subtle
	problem in the outcome of transfig, but some old font changing
	commands behave differnet now.
     2. To use the \epsfig-package distributed with LaTeX2e instead
	of \special{psfile... for included PS-figures.
   They use two new defines in the dev/Imakefile: -DNFSS for 1., -DEPSF for 2.
   From Hendrik G. Seliger (hank@blimp.automat.uni-essen.de)
o arrow heads are pointed now for PostScript (they were blunt before)
o EPS Objects have been generalized to Picture Objects. Currently EPS, XBM
	XPM (X11 color pixmap) and GIF formats are recognized.
	Compressed (.Z) and gzipped (.z or .gz) files are also handled.
o new command-line option '-z' for PostScript output used to select a paper
	size from the list of A4, B5, Letter, Legal.
	from Jon Roma (roma@ux1.cso.uiuc.edu)
o change to the pstex driver so that when it sees text with a LaTeX font it
	handles it using the LaTeX text object routine, but not treating it
	as "special" text. This allows the pstex driver to take the "hint"
	the since the user is using LaTeX font specifiers, those should be
	used. The only people who could be adversely affected by the change
	would be those using LaTeX font names as convenient synonyms for
	PS font names who would now get LaTeX fonts instead. Probably not
	a problem.
	from Micah Beck (beck@cs.utk.ecu)
o fig2ps2tex.sh for systems which don't have csh or dc.  Uses bc and awk.
	from Dave Raymond (raymond@kestrel.nmt.edu)


o changes to the file format (protocol).  See *xfig* Doc/FORMAT3.0 for details.
	Transfig will still read older Fig file formats.
Here are the features involving change to the protocol:
   o portrait/landscape, justification (center or flush left) and metric/inches
	indicators saved with figure file so is not necessary to supply the
	command-line args to specify them.  However they will override the file
	specification if given.
   o separate border and fill colors.
   o resolution is increased from 80 ppi to 1200 ppi.  This decreases jaggies.
	A side effect is that fig2dev can now read Fig files of any resolution.
   o there are now 32 colors - new ones are: gold, three shades each of blue,
	green, cyan, red, magenta, brown and pink.
   o in addition, there are now user-definable colors which are stored in the
	figure file as pseudo-objects of type 0 which define the rgb values
	in hexadecimal.  The color numbers range from 32 to 543 for a maximum
	of 512 user-defined colors.
   o more fill options - colors transition from black to full saturation
	(shades) and on to full white (tints, i.e. pastels).
	Or you can use one of 16 fill patterns - diagonal lines, bricks,
	shingles, crosshatch etc.
   o three line-join styles: miter (current style), round and bevel (see
	PostScript or Xlib reference for description)
   o three line-cap styles: butt (current style), round and projecting (see
	PostScript or Xlib reference for description)

Bugs fixed:

o circles/ellipses paths weren't being closed in postscript output - gap closed
o "%%Page: 1 1" added for single-page output for Document Structuring Compliancy
	(previously, Page: comment only appeared in multi-page figures)
o coord_system was declared extern in fig2dev/fig2dev.h.  This was incorrect.
o even/odd rule fill now used for filled objects as per xfig (PostScript)
o typo in fig2dev/dev/Imakefile said include -DA4d instead of -DA4 for A4 paper
o all orientations of rotated/flipped EPS objects correctly done now
o man pages for transfig claims to be able to read postscript files - this was
	never finished so it has been removed from the man pages.
o dotted lines with very small length caused SIGFPE
o typo in error message about unknown option
o added check for #if defined(SVR4) in addition to defined(SYSV)
o misplaced ';' in fig2dev.c gendev_null() proc
o added static declarations in genlatex.c genpictex.c and gentextyl.c
o better bounding box calculation
	from Uwe Bonnes (bon@lte.e-technik.uni-erlangen.de)
o Tpic TeX font position 5 was "sl" (slanted) which doesn't exist
	from Edward Wang (edward@cs.berkeley.edu)

===============================================================================
Version 2.1
===============================================================================

Transfig version 2.1.8 (Oct 1, 1993)

New Features:

Bugs fixed:

o thick line threshold increased from 1 to 2 for latex lines
o save/restore wraps EPS objects now
o specifing nonexistant font with -f caused coredump
	from Gordon W. Ross (gwr@jericho.mc.com)
o newpath command given before EPS object for PostScript output
o moved definition of SetFigFont to better place 
	from Bernd Raichle (raichle@isr.uni-stuttgart.de)
o #included sys/types for BSD4_3 systems in genps.c 
o bug in eepic output - SetFigFont was being defined inside a \put
	from Vivek Khera (khera@cs.duke.edu)
o BoundingBox for EPS objects can be floating values
o shortened file name (fig2dev/dev/)def_setfigfont.c to setfigfont.c
o distribution version of fig2dev/dev/Makefile had (def_)setfigfont.c
	instead of (def_)setfigfont.o in LIBOBJS definition
o SUBDIR fig2dev/dev was missing from top-level Imakefile caused problems
	where make would say something like "No rule to make target 
	dev/libtransfig.a"

---------------------------------------------------------------------------
Transfig version 2.1.7

o no longer writes over input file if there is an error in the command line
o added "%%Orientation: Landscape" comment for PostScript output in landscape
	orientation
o moved definition of SetFigFont from transfig into genpstex.c so that there
	is no need to run transfig for pstex output
o script pic2tpic was generating \ss instead of \sf for \fH
	from Mark Roth (mroth@afit.af.mil)
o changed header for Encapsulated postscript files from "%!PS-Adobe-2.0 EPSF"
	to "%!PS-Adobe-2.0 EPSF-2.0" which allows FrameMaker and ghostview to
	read them properly.
	from Vivek Khera (khera@cs.duke.edu)
o check for #ifdef SYSV to include string.h instead of strings.h in 
	fig2dev/dev/genibmgl.c
o changed EXTRA_LIBRARIES to SYS_LIBRARIES in fig2dev/Imakefile so wouldn't 
	clobber system-dependent flags in EXTRA_LIBRARIES
o fprintf and 'else' missing from genepic which caused incorrect information 
	to be generated when drawing arcs using epic output
o removed dependencies on the X libraries (Imakefiles and Makefiles)
o SGI machines had trouble with hypot() which caused arrow heads to mess up
	from Malcolm Davis (davis@nod.bms.com)
o Flipped EPS objects were incorrectly flipped on output
	from Brian Boyter (boyter@pyrdc.va.pyramid.com)
o POLYLINES were being drawn in sections (10 points per section) which 
	resulted in incorrect dashed line lengths and only one section 
	filled if area fill was on
	from Peter Egelberg (egel@neural.se)
o added Sequent machines and Suns with SunOs < 4.1 to list of machines that
	don't have strstr()
	from Scott Erikson (sources@ics.uci.edu)
o removed PATCHLEVEL from patchlevel.h file - version number is complete with 
	three parts (e.g. 2.1.6)
o removed "extern coord_system" from fig2dev.h (wasn't used by fig2dev)
o SPECIAL_CHAR split into three strings for systems which can't handle one
o -P flag dissappeared from eepic output language - reinstated

---------------------------------------------------------------------------
Version 2.1.6

o Courier-BoldItalic changed to Courier-BoldOblique for PostScript fonts
o "if" statement replaces copysign() call since some machines don't have it
o some backslashes ('\') corrected in printf statements in transfig/mkfile.c and
	fig2dev/iso2tex.c
o changed header for postscript files from "%!" to "%!PS-Adobe-2.0" when using
	-P (showpage) option and "%!PS-Adobe-2.0 EPSF" otherwise (Encapsulated)
o corrupt transfig/Imakefile and typo (SCRS instead of SRCS)
o some variables (cur_thickness and coord_system) were multiply defined in 
	various drivers in fig2dev/dev - made those static
